package mezz.jei.common.network.packets;

import mezz.jei.common.network.IPacketId;
import mezz.jei.common.network.PacketIdServer;
import mezz.jei.common.network.ServerPacketContext;
import mezz.jei.common.network.ServerPacketData;
import mezz.jei.common.platform.IPlatformRegistry;
import mezz.jei.common.platform.Services;
import mezz.jei.core.config.IServerConfig;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_2378;
import net.minecraft.class_2540;
import net.minecraft.class_3222;
import mezz.jei.common.util.ServerCommandUtil;
import java.util.Optional;

public class PacketDeletePlayerItem extends PacketJei {
	private final class_1799 itemStack;

	public PacketDeletePlayerItem(class_1799 itemStack) {
		this.itemStack = itemStack;
	}

	@Override
	public IPacketId getPacketId() {
		return PacketIdServer.DELETE_ITEM;
	}

	@Override
	public void writePacketData(class_2540 buf) {
		IPlatformRegistry<class_1792> registry = Services.PLATFORM.getRegistry(class_2378.field_25108);
		int itemId = registry.getId(itemStack.method_7909());
		buf.method_10804(itemId);
	}

	public static void readPacketData(ServerPacketData data) {
		IPlatformRegistry<class_1792> registry = Services.PLATFORM.getRegistry(class_2378.field_25108);
		class_2540 buf = data.buf();
		ServerPacketContext context = data.context();
		class_3222 player = context.player();
		IServerConfig serverConfig = context.serverConfig();
		int itemId = buf.method_10816();
		Optional<class_1792> value = registry.getValue(itemId);
		if (value.isPresent() && ServerCommandUtil.hasPermissionForCheatMode(player, serverConfig)) {
			class_1799 playerItem = player.field_7512.method_34255();
			if (playerItem.method_7909() == value.get()) {
				player.field_7512.method_34254(class_1799.field_8037);
			}
		}
	}
}
